# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify Alma, CentOS, CentOS Stream and Rocky Linux as rhel
%if "%{__distinit}" == "a" || "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "cs" || "%{__distinit}" == "rl"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

Summary:	Incredibly simple helpers for testing code with exceptions 
Name:		perl-Test-Fatal
Version:	0.017
Release:	2.%{__distinit}%{__distvers}
License:	GPL-1.0-or-later OR Artistic-1.0-Perl
URL:		https://metacpan.org/release/Test-Fatal
Source0:	https://cpan.metacpan.org/modules/by-module/Test/Test-Fatal-%{version}.tar.gz
Patch0:		Test-Fatal-0.017-old-EU::MM.patch
BuildArch:	noarch
# Module Build
BuildRequires:	coreutils
BuildRequires:	findutils
BuildRequires:	make
BuildRequires:	perl-generators
BuildRequires:	perl-interpreter
BuildRequires:	perl(ExtUtils::MakeMaker) >= 6.31
# Module Runtime
BuildRequires:	perl(Carp)
BuildRequires:	perl(Exporter) >= 5.57
BuildRequires:	perl(strict)
BuildRequires:	perl(Test::Builder)
BuildRequires:	perl(Try::Tiny) >= 0.07
BuildRequires:	perl(warnings)
# Test Suite
BuildRequires:	perl(File::Spec)
BuildRequires:	perl(overload)
BuildRequires:	perl(Test::Builder::Tester)
BuildRequires:	perl(Test::More) >= 0.65
# Optional Tests
BuildRequires:	perl(CPAN::Meta) >= 2.120900
# Extra Tests
BuildRequires:	perl(Encode)
BuildRequires:	perl(Test::Pod) >= 1.41
# Dependencies
%if 0%{?fedora} < 38 && 0%{?rhel} < 10
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))
%endif
Requires:	perl(Test::Builder)

%description
Test::Fatal is an alternative to the popular Test::Exception. It does much
less, but should allow greater flexibility in testing exception-throwing code
with about the same amount of typing.

%prep
%setup -q -n Test-Fatal-%{version}

# Don't really need ExtUtils::MakeMaker ≥ 6.78
%patch -P 0

# Avoid doc-file dependencies
chmod -c -x examples/*

%build
perl Makefile.PL INSTALLDIRS=vendor
make %{?_smp_mflags}

%install
make pure_install DESTDIR=%{buildroot}
find %{buildroot} -type f -name .packlist -delete
%{_fixperms} -c %{buildroot}

%check
make test
make test TEST_FILES="$(echo $(find xt/ -name '*.t'))"

%files
%license LICENSE
%doc Changes README examples/
%{perl_vendorlib}/Test/
%{_mandir}/man3/Test::Fatal.3*

%changelog
* Thu Jul 13 2023 Paul Howarth <paul@city-fan.org> - 0.017-2
- Avoid use of deprecated patch syntax

* Sun Jan  1 2023 Paul Howarth <paul@city-fan.org> - 0.017-1
- Update to 0.017
  - Update packaging and metadata
- Use SPDX-format license tag
- Use %%license unconditionally
- Add patch to support building with ExtUtils::MakeMaker < 6.78

* Mon Aug 10 2020 Paul Howarth <paul@city-fan.org> - 0.016-1
- Update to 0.016
  - Add default descriptions to tests
  - Work on ancient Test::Builder code
- Switch upstream from search.cpan.org to metacpan.org

* Tue Apr 10 2018 Paul Howarth <paul@city-fan.org> - 0.014-9
- BR: perl-generators unconditionally
- BR: perl-interpreter rather than perl
- Drop support for EOL distributions prior to F-13
  - Drop BuildRoot: and Group: tags
  - Drop explicit buildroot cleaning in %%install section
  - Drop explicit %%clean section
  - Drop workaround for building with Test::More < 0.96

* Sat Oct  1 2016 Paul Howarth <paul@city-fan.org> - 0.014-5
- BR: perl-generators where available
- Simplify find command using -delete

* Wed Dec 10 2014 Paul Howarth <paul@city-fan.org> - 0.014-1
- Update to 0.014
  - Avoid assuming that t/todo.t is always called t/todo.t
- Classify buildreqs by usage

* Thu Sep 11 2014 Paul Howarth <paul@city-fan.org> - 0.013-3
- Drop support for building with ExtUtils::MakeMaker < 6.30
- Drop %%defattr, redundant since rpm 4.4
- Use %%license where possible

* Mon Sep 23 2013 Paul Howarth <paul@city-fan.org> - 0.013-1
- Update to 0.013
  - Rebuild to get a newer compile test that may work on 5.6.x
- Reinstate support for old distributions by bundling a copy of Test::More 0.96
  to use for the test suite if the system one is too old

* Tue Sep 17 2013 Paul Howarth <paul@city-fan.org> - 0.012-1
- Update to 0.012
  - More clearly (and correctly) document the way NOT to use Test::Fatal
  - Try to fix $TODO not working when the user test uses $T::B::Level
  - Go back to auto-detecting the required Test::More, reverting the changes
    made for CPAN RT#62699
- Explicitly run the extra tests
- Package examples directory as documentation
- Drop support for old distributions as we now need Test::More ≥ 0.96

* Sat Jun 23 2012 Paul Howarth <paul@city-fan.org> - 0.010-2
- BR:/R: perl(Test::Builder)
- Don't need to remove empty directories from the buildroot
- Drop support for old distribution prior to FC-3:
  - Don't need to define %%{perl_vendorlib}

* Thu Feb 16 2012 Paul Howarth <paul@city-fan.org> - 0.010-1
- Update to 0.010
  - Avoid tickling an overloading bug in perl 5.6 during testing
    (CPAN RT#74847)

* Fri Feb 10 2012 Paul Howarth <paul@city-fan.org> - 0.009-1
- Update to 0.009
  - Advise against using isnt(exception{...},undef)

* Mon Nov  7 2011 Paul Howarth <paul@city-fan.org> - 0.008-1
- Update to 0.008
  - Revert the mistake by which 0.004 allowed blocks after "exception" as well
    as "success"
- BR: perl(Carp)
- Update patch for building with ExtUtils::MakeMaker < 6.30

* Sat Jul  2 2011 Paul Howarth <paul@city-fan.org> - 0.006-2
- Rebuild for perl 5.14.1 in Rawhide
- Fix dist tag for CentOS 6 and Scientific Linux

* Thu Jun  2 2011 Paul Howarth <paul@city-fan.org> - 0.006-1
- Update to 0.006
  - Crank back the Test::More and Exporter requirements (CPAN RT#62699)
  - Add lives_ok and dies_ok emulation (CPAN RT#67598)
- Versions patch replaced by workaround for old ExtUtils::MakeMaker
- BR: perl(Test::Builder::Tester)

* Tue Apr 26 2011 Paul Howarth <paul@city-fan.org> - 0.005-1
- Update to 0.005
  - Fix the logic that picks tests for 5.13.1+

* Tue Apr 26 2011 Paul Howarth <paul@city-fan.org> - 0.004-1
- Update to 0.004
  - success blocks now allow trailing blocks like finally, catch, etc.
- Nobody else likes macros for commands
- Use %%{_fixperms} macro instead of our own chmod incantation

* Fri Oct 29 2010 Paul Howarth <paul@city-fan.org> - 0.003-1
- Update to 0.003
  - More tests for false exceptions, especially on 5.13
- Update versions patch

* Thu Oct 28 2010 Paul Howarth <paul@city-fan.org> - 0.002-1
- Update to 0.002
  - Add tests for handling of false exceptions
  - Fix precedence error in documentation
- Update versions patch

* Tue Oct 26 2010 Paul Howarth <paul@city-fan.org> - 0.001-1
- Initial RPM version
